# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support
%bcond_without repolib

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define repodir %{_javadir}/repository.jboss.com/org/apache/james/apache-mime4j/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

%define james_parent_version 1.1
%define james_project_version 1.2

Name:           apache-james
Version:        0.6
Release:        6%{?dist}
Epoch:          0
Summary:        Java stream based MIME message parser
License:        APL 2.0
Group:          Development/Java
URL:            http://james.apache.org/mime4j 
Source0:        http://apache.multihomed.net/james/mime4j/apache-mime4j-0.6-src.tar.gz
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-settings.xml
Source5:        %{name}-component-info.xml
Source6:        %{name}-upload.sh
Patch0:         apache-mime4j-pom_xml.patch
Requires(post): jpackage-utils >= 0:1.7.2
Requires(postun): jpackage-utils >= 0:1.7.2
Requires:       jpackage-utils
BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  maven2 >= 2.0.4-10
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-surefire-report
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-pmd
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  mojo-maven2-plugin-javacc
BuildRequires:  maven2-common-poms >= 1.0
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-commons-io
BuildRequires:  maven-doxia-sitetools
BuildRequires:  javacc
BuildRequires:  log4j
BuildRequires:  junit
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Mime4j provides a parser, MimeStreamParser, for e-mail message streams in plain rfc822 and MIME format.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n apache-mime4j-%{version}
%patch0
%{_bindir}/find -type f -name "*.jar" | %{_bindir}/xargs -t %{__rm}

cp -p %{SOURCE2} settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/

cp -p stage/org.apache.james/poms/james-parent-1.1.pom $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/JPP.org.apache.james-james-parent.pom
cp -p stage/org.apache.james/poms/james-project-1.2.pom $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/JPP.org.apache.james-james-project.pom
%{_bindir}/mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.mode=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        install

%install
rm -rf %{buildroot}
# jars
mkdir -p %{buildroot}%{_javadir}/
install -pm 644 target/apache-mime4j-%{version}.jar %{buildroot}%{_javadir}/apache-mime4j-%{version}.jar
(cd %{buildroot}%{_javadir} && %{__ln_s} apache-mime4j-%{version}.jar apache-mime4j.jar)

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# pom
mkdir -p %{buildroot}%{_datadir}/maven2/poms
install -pm 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-apache-mime4j.pom
%add_to_maven_depmap org.apache.james apache-mime4j %{version} JPP apache-mime4j
install -pm 644 stage/org.apache.james/poms/james-parent-1.1.pom %{buildroot}%{_datadir}/maven2/poms/JPP-james-parent.pom
%add_to_maven_depmap org.apache.james james-parent %{james_parent_version} JPP james-parent
install -pm 644 stage/org.apache.james/poms/james-project-1.2.pom %{buildroot}%{_datadir}/maven2/poms/JPP-james-project.pom
%add_to_maven_depmap org.apache.james james-project %{james_project_version} JPP james-project

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %with repolib
mkdir -p %{buildroot}%{repodir}
mkdir -p %{buildroot}%{repodirlib}
cp -p %{SOURCE5} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
mkdir -p %{buildroot}%{repodirsrc}
cp -p %{SOURCE0} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/apache-mime4j-%{version}.jar %{buildroot}%{repodirlib}/apache-mime4j.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-apache-mime4j.pom %{buildroot}%{repodirlib}/apache-mime4j.pom
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-james-parent.pom %{buildroot}%{repodirlib}/james-parent.pom
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-james-project.pom %{buildroot}%{repodirlib}/james-project.pom
cp -p %{SOURCE6} %{buildroot}%{repodir}/upload.sh
pushd %{buildroot}%{repodir}
/bin/sh ./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
popd
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%{_javadir}*/apache-mime4j-%{version}.jar
%{_javadir}*/apache-mime4j.jar
%{_datadir}/maven2/poms/JPP-apache-mime4j.pom
%{_datadir}/maven2/poms/JPP-james-parent.pom
%{_datadir}/maven2/poms/JPP-james-project.pom
%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/apache-mime4j-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Dec 10 2010 David Walluck <dwalluck@redhat.com> 0:0.6-6
- fix POM names
- Requires: jpackage-utils
- fix file ownership in main and repolib packages
- fix component-info.xml in repolib
- fix repolib copying
- use BuildRequires: maven2-plugin-deploy
- move some maven commands from build to prep stage
- fix GCJ support
- fix file list

* Wed Nov 17 2010 Permaine Cheung <pcheung@redhat.com> - 0:0.6-5.2.2
- Add upload.sh and content of maven2-brew to repolib
- Fix %%files for signed jars
- Fix License tag to use the correct short name
- Remove all jars in the source tar ball
- Add depmaps for some indirect deps

* Fri May 14 2010 Martha Benitez <mbenitez@redhat.com> - 0:0.6-5.2.1
- rebuilt

* Mon Apr 19 2010 Luiz Barreiros <gbarreir@redhat.com> 0:0.6-5.2
- Rebuild

* Wed Jan 8 2010 Yiqiao Wang <yiwang@redhat.com> 0:0.6-5.1
- Disable aot compile

* Wed Dec 23 2009 Fernando Nasser <fnasser@redhat.com> 0:0.6-5
- Make POM and artifact names match

* Tue Dec 22 2009 Fernando Nasser <fnasser@redhat.com> 0:0.6-4
- Fix parent and project POM fragments

* Tue Dec 22 2009 Fernando Nasser <fnasser@redhat.com> 0:0.6-3
- Fix POM filenames

* Thu Dec 17 2009 Yong Yang <yyang@redhat.com> 0:0.6-2
- Add repolib

* Mon Nov 02 2009 Yong Yang <yyang@redhat.com> 0:0.6-1
- First release
